diff --git a/doc/guix-cookbook.texi b/doc/guix-cookbook.texi
index 4c2b23786c..e41d584813 100644
--- a/doc/guix-cookbook.texi
+++ b/doc/guix-cookbook.texi
@@ -2453,7 +2453,7 @@ Xorg
 can be achieved by adding the following service to your @file{config.scm}:
 
 @lisp
-(service screen-locker-services-type
+(service screen-locker-service-type
          (screen-locker-configuration
           (name "slock")
           (program (file-append slock "/bin/slock"))))
diff --git a/po/doc/guix-cookbook.de.po b/po/doc/guix-cookbook.de.po
index c10cfe2922..508fb522a2 100644
--- a/po/doc/guix-cookbook.de.po
+++ b/po/doc/guix-cookbook.de.po
@@ -4520,12 +4520,12 @@ msgstr "Damit slock aber überhaupt die Berechtigung dafür erteilt bekommt, Bil
 #: guix-git/doc/guix-cookbook.texi:2460
 #, no-wrap
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
 msgstr ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
diff --git a/po/doc/guix-cookbook.fr.po b/po/doc/guix-cookbook.fr.po
index f22aa9d7e8..a75240dc0b 100644
--- a/po/doc/guix-cookbook.fr.po
+++ b/po/doc/guix-cookbook.fr.po
@@ -4537,12 +4537,12 @@ msgstr "Pour que slock puisse verrouiller l'écran de la session graphique, il d
 #: guix-git/doc/guix-cookbook.texi:2460
 #, no-wrap
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
 msgstr ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
diff --git a/po/doc/guix-cookbook.ko.po b/po/doc/guix-cookbook.ko.po
index a3624f095a..6c4ba97c61 100644
--- a/po/doc/guix-cookbook.ko.po
+++ b/po/doc/guix-cookbook.ko.po
@@ -4208,7 +4208,7 @@ msgstr ""
 #: guix-git/doc/guix-cookbook.texi:2459
 #, no-wrap
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
diff --git a/po/doc/guix-cookbook.pt_BR.po b/po/doc/guix-cookbook.pt_BR.po
index 509d12cede..e7198a37d4 100644
--- a/po/doc/guix-cookbook.pt_BR.po
+++ b/po/doc/guix-cookbook.pt_BR.po
@@ -4538,12 +4538,12 @@ msgstr "Para que o slock possa ser um bloqueador de tela para a sessão gráfica
 #: doc/guix-cookbook.texi:2460
 #, no-wrap
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
 msgstr ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
diff --git a/po/doc/guix-cookbook.sk.po b/po/doc/guix-cookbook.sk.po
index 37d1568896..1aa0b5e527 100644
--- a/po/doc/guix-cookbook.sk.po
+++ b/po/doc/guix-cookbook.sk.po
@@ -4507,7 +4507,7 @@ msgstr "Aby mohol slock uzamknúť obrazovku grafického sedenia, musí mať nas
 #| "         (postgresql-configuration\n"
 #| "          (postgresql postgresql-14)))\n"
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"
diff --git a/po/doc/guix-cookbook.sv.po b/po/doc/guix-cookbook.sv.po
index 276d6e5e83..93f6bb16b8 100644
--- a/po/doc/guix-cookbook.sv.po
+++ b/po/doc/guix-cookbook.sv.po
@@ -3877,7 +3877,7 @@ msgstr ""
 #: doc/guix-cookbook.texi:2460
 #, no-wrap
 msgid ""
-"(service screen-locker-services-type\n"
+"(service screen-locker-service-type\n"
 "         (screen-locker-configuration\n"
 "          (name \"slock\")\n"
 "          (program (file-append slock \"/bin/slock\"))))\n"